freeslot("SPR_WLHL","SPR_WLSP", "S_CLIMBWALL_HOLD","S_CLIMBWALL_SPIN")
states[S_CLIMBWALL_HOLD] = {SPR_WLHL,FF_ANIMATE|FF_PAPERSPRITE,18,nil,G,2,S_NULL}
states[S_CLIMBWALL_SPIN] = {SPR_WLSP,FF_ANIMATE|FF_PAPERSPRITE,10,nil,E,2,S_NULL}

addHook("ShieldSpecial", function(player)
	if player.valid and player.mo and player.mo.valid
	and player.playerstate == PST_LIVE
		if player.climbspin and player.climbspin.holdwall
			return true
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.valid and player.mo and player.mo.valid
	and player.playerstate == PST_LIVE
		local mo = player.mo
		if not player.climbspin
			player.climbspin = {}
		else
			local c = player.climbspin
			c.walltime = $ or 0
			c.wang = $ or 0
			c.holdwall = $ or 0
			
			if c.holdwall then c.holdwall = $-1 end
			
			c.walljump = $ or 0
			if c.walljump
				c.walljump = $-1
				
				if player.speed and (c.walljump%5) <= 0
					local momang = R_PointToAngle2(0,0,player.rmomx,player.rmomy)
					for i = 0,1
						local ax = P_ReturnThrustX(nil,momang+ANGLE_90+(ANGLE_180*i),mo.radius)
						local ay = P_ReturnThrustY(nil,momang+ANGLE_90+(ANGLE_180*i),mo.radius)
						
						local px = P_ReturnThrustX(nil,momang,mo.radius*3/2)
						local py = P_ReturnThrustY(nil,momang,mo.radius*3/2)
						
						local s = P_SpawnMobjFromMobj(mo,ax,ay,mo.height/2,MT_PARTICLE)
						s.state = S_CLIMBWALL_SPIN
						s.angle = R_PointToAngle2(s.x,s.y,mo.x+player.rmomx+px,mo.y+player.rmomy+py)
						s.color = (c.airjump and SKINCOLOR_RED) or SKINCOLOR_TEAL
						
						s.momx = mo.momx*2/3
						s.momy = mo.momy*2/3
						s.momz = mo.momz
					end
				end
				c.waswall = true
			elseif c.waswall
				c.waswall = false
				c.airjump = false
			end
			
			c.astate = $ or 0
			c.atime = $ or 0
			if c.astate
				c.atime = $+1
				
				local fy = 8
					local fx = 8
					
					local dy = (FRACUNIT-mo.spriteyscale)/fy
					local dx = (FRACUNIT-mo.spritexscale)/fx
					
					if dy then mo.spriteyscale = $+dy end
					if dx then mo.spritexscale = $+dx end
				if c.astate == 1
					player.drawangle = c.wang
					player.pflags = ($|PF_THOKKED|PF_JUMPED|PF_NOJUMPDAMAGE) &~(PF_STARTJUMP|PF_SPINNING)
					mo.state = S_PLAY_RIDE
					P_InstaThrust(mo,player.drawangle,mo.scale)
					mo.momz = $/2
					
					if c.atime >= 12
						c.astate = 2
						c.atime = 0
						
						mo.spritexscale = FRACUNIT*3/4
						mo.spriteyscale = FRACUNIT/4*7
						P_SetObjectMomZ(mo,14*FRACUNIT)
						S_StartSound(mo,sfx_spin)
						
						mo.state = S_PLAY_ROLL
					end
				elseif c.astate == 2
					if c.holdwall
						player.drawangle = c.wang
						P_Thrust(mo,player.drawangle,6*mo.scale)
					
						c.walltime = $+1
						if (c.walltime%5) <= 0
							local ax = P_ReturnThrustX(nil,c.wang,mo.radius)
							local ay = P_ReturnThrustY(nil,c.wang,mo.radius)
							
							local hx = P_ReturnThrustX(nil,c.wang,mo.radius/2)
							local hy = P_ReturnThrustY(nil,c.wang,mo.radius/2)
							
							local rr = P_RandomRange(-FixedInt(mo.radius),FixedInt(mo.radius))*FRACUNIT
							local rx = P_ReturnThrustX(nil,c.wang+ANGLE_90,rr)
							local ry = P_ReturnThrustY(nil,c.wang+ANGLE_90,rr)
							
							local h = P_SpawnMobjFromMobj(mo,ax+rx,ay+ry,player.spinheight,MT_PARTICLE)
							h.state = S_CLIMBWALL_HOLD
							h.renderflags = $|RF_VERTICALFLIP
							
							local px = mo.x
							local py = mo.y
							h.angle = R_PointToAngle2(px+ax,py+ay,px+hx+rx,py+hy+ry)
							h.momz = player.mo.momz-((2*mo.scale)*P_MobjFlip(mo))
						end
					end
					
					P_SpawnThokMobj(player)
					player.pflags = ($|PF_THOKKED|PF_JUMPED) &~(PF_STARTJUMP|PF_NOJUMPDAMAGE|PF_SPINNING)
					if player.cmd.buttons & BT_JUMP
						P_DoJump(player)
						P_SetObjectMomZ(mo,6*FRACUNIT,true)
						
						if c.holdwall
							P_InstaThrust(mo,player.drawangle,-20*mo.scale)
							player.drawangle = $+ANGLE_180
						else
							c.airjump = true
						end
						
						player.pflags = $&~PF_THOKKED
						c.walljump = 16
						
						c.astate = 0
						c.atime = 0
						
						mo.spritexscale = FRACUNIT
						mo.spriteyscale = FRACUNIT
					end
					
					if mo.momz*P_MobjFlip(mo) < 0
						c.astate = 0
						c.atime = 0
						
						mo.spritexscale = FRACUNIT
						mo.spriteyscale = FRACUNIT
					end
				end
			elseif c.atime
				c.atime = 0
			end
		end
	end
end)

local function CS_DoWallShit(player,ang,sec,line)
	local c = player.climbspin
	local mo = player.mo
	
	c.holdwall = 3
	if not P_IsObjectOnGround(mo)
	and not (player.pflags & PF_THOKKED)
		c.walltime = $+1
		if (c.walltime%5) <= 0
			local ax = P_ReturnThrustX(nil,ang,mo.radius)
			local ay = P_ReturnThrustY(nil,ang,mo.radius)
			
			local hx = P_ReturnThrustX(nil,ang,mo.radius/2)
			local hy = P_ReturnThrustY(nil,ang,mo.radius/2)
			
			local rr = P_RandomRange(-FixedInt(mo.radius),FixedInt(mo.radius))*FRACUNIT
			local rx = P_ReturnThrustX(nil,ang+ANGLE_90,rr)
			local ry = P_ReturnThrustY(nil,ang+ANGLE_90,rr)
			
			local h = P_SpawnMobjFromMobj(mo,ax+rx,ay+ry,0,MT_PARTICLE)
			h.state = S_CLIMBWALL_HOLD
			
			local px = mo.x
			local py = mo.y
			h.angle = R_PointToAngle2(px+ax,py+ay,px+hx+rx,py+hy+ry)
			h.momz = player.mo.momz+((2*mo.scale)*P_MobjFlip(mo))
		end
		if player.cmd.buttons & BT_SPIN
			player.drawangle = ang
			mo.momz = $/2
			mo.state = S_PLAY_RIDE
			
			mo.spritexscale = FRACUNIT/4*6
			mo.spriteyscale = FRACUNIT*3/4
			
			c.astate = 1
			c.atime = 0
			S_StartSound(mo,sfx_s3k4a)
		end
	end
end

addHook("MobjMoveBlocked", function(mo,mobj,line) --Wall check
	if mo and mo.valid
	and not (mobj and mobj.valid and mobj.flags & (MF_MONITOR|MF_ENEMY|MF_BOSS))
	and mo.player and mo.player.valid
	and mo.skin == "jason" and mo.player.climbspin
	and not (mo.player.pflags & PF_STASIS)
	and mo.player.playerstate == PST_LIVE
		if not (mo.player and mo.player.valid) then return end
		if line and line.valid
			local player = mo.player
			local ang = (player.climbspin.climbing and player.climbspin.climbing.ang) or 0
			if PTR_GlideClimbTraverse(mo,line)
				local real,ang,sec = PTR_GlideClimbTraverse(mo,line)
				if (P_IsClimbingValid(mo.player,ang) or (mobj and mobj.valid))
					if mobj and mobj.valid then ang = R_PointToAngle2(mo.x,mo.y,mobj.x,mobj.y) or 0 end
					CS_DoWallShit(mo.player,ang,sec,line)
					mo.player.climbspin.wang = ang
				end
			end
		elseif mobj and mobj.valid
			local ang = R_PointToAngle2(mo.x,mo.y,mobj.x,mobj.y) or 0
			CS_DoWallShit(mo.player,ang)
			mo.player.climbspin.wang = ang
		end
	end
end,MT_PLAYER)